LeetCode oj 167. Two Sum II - Input array is sorted (双指针)

167. Two Sum II - Input array is sorted

 
Question Editorial Solution
  My Submissions
  • Total Accepted: 29576
  • Total Submissions: 61336
  • Difficulty: Medium

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

给你一个有序序列和一个目标值,问序列里哪两个元素的和是目标值。

之前没注意到是有序的,就直接暴力加剪枝了,后来看别人做法才知道是有序的,经典的双指针,一个从前往后找,一个从后往前找,时间复杂度O(n)

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int a[] = new int [2];
        int len = numbers.length;
        int index_1 = 0,index_2 = len-1;
        int flag = 0;
        while(index_1 < index_2){
            if(numbers[index_1] + numbers[index_2] > target){
                index_2--;
            }
            else if(numbers[index_1] + numbers[index_2] < target){
                index_1++;
            }
            else{
                a[0] = index_1+1;
                a[1] = index_2+1;
                break;
            }
        }
        return a;
    }
}


你可能感兴趣的:(LeetCode,167.,Two,Sum,II,-,In)